/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Sun Microsystems, Inc.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * $RCSfile: ContextHelper.hxx,v $
 * $Revision: 1.4 $
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#ifndef CHART_CONTEXTHELPER_HXX
#define CHART_CONTEXTHELPER_HXX

#include <comphelper/InlineContainer.hxx>

#include <com/sun/star/uno/XComponentContext.hpp>
#include <com/sun/star/uno/Any.hxx>
#include <rtl/ustring.hxx>

#include <map>

namespace chart
{

namespace ContextHelper
{

typedef ::std::map< ::rtl::OUString, ::com::sun::star::uno::Any >
    tContextEntryMapType;
typedef ::comphelper::MakeMap< ::rtl::OUString, ::com::sun::star::uno::Any >
    MakeContextEntryMap;

/** creates a component context containing the properties given in the map.

    @param rDelegateContext
        delegation to further context
 */
::com::sun::star::uno::Reference< ::com::sun::star::uno::XComponentContext >
    createContext( const tContextEntryMapType & rMap,
                   const ::com::sun::star::uno::Reference<
                       ::com::sun::star::uno::XComponentContext > & rDelegateContext =
                   ::com::sun::star::uno::Reference< ::com::sun::star::uno::XComponentContext >() );

} //  namespace ContextHelper

} //  namespace chart

// CHART_CONTEXTHELPER_HXX
#endif
